import { defineComponent as O, shallowRef as _, computed as h, onMounted as X, createVNode as y, reactive as H, onBeforeUnmount as K, watch as U, mergeProps as C, ref as Q, isVNode as p } from "vue";
function k() {
  return typeof window < "u" && "IntersectionObserver" in window && "isIntersecting" in window.IntersectionObserverEntry.prototype;
}
const E = {}, ee = (e) => {
  e.forEach((t) => {
    t.isIntersecting && t.target.onVisible();
  });
}, te = (e) => (E[e] = E[e] || new IntersectionObserver(ee, {
  rootMargin: e + "px"
}), E[e]), F = () => typeof window > "u" ? 0 : window.scrollX || window.pageXOffset, z = () => typeof window > "u" ? 0 : window.scrollY || window.pageYOffset, B = () => ({
  afterLoad: {
    type: Function,
    default: () => {
    }
  },
  beforeLoad: {
    type: Function,
    default: () => {
    }
  },
  scrollPosition: {
    type: Object,
    default: null
  },
  visibleByDefault: {
    type: Boolean,
    default: !1
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  style: {
    type: Object,
    default: () => {
    }
  },
  class: {
    type: String,
    default: ""
  },
  delayMethod: {
    type: String,
    default: "throttle"
  },
  delayTime: {
    type: Number,
    default: 300
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), ne = () => ({
  ...B(),
  onImageError: {
    type: Function,
    default: () => {
    }
  },
  effect: {
    type: String,
    default: ""
  },
  placeholderSrc: {
    type: String,
    default: ""
  },
  wrapperClassName: {
    type: String,
    default: ""
  },
  wrapperProps: {
    type: Object,
    default: () => ({})
  },
  loadedClassName: {
    type: String,
    default: ""
  }
}), re = () => ({
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 100
  },
  width: {
    type: Number,
    default: 100
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), ie = () => ({
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), Y = /* @__PURE__ */ O({
  name: "PlaceholderWithoutTracking",
  props: re(),
  setup(e) {
    const t = _(), r = h(() => !e.scrollPosition && e.useIntersectionObserver && k()), l = h(() => r.value ? te(e.threshold) : null);
    function c(o = e.scrollPosition) {
      const n = t.value.getBoundingClientRect(), s = t.value.style, f = {
        left: parseInt(s.getPropertyValue("margin-left"), 10) || 0,
        top: parseInt(s.getPropertyValue("margin-top"), 10) || 0
      };
      return {
        bottom: o.y + n.bottom + f.top,
        left: o.x + n.left + f.left,
        right: o.x + n.right + f.left,
        top: o.y + n.top + f.top
      };
    }
    function d() {
      if (typeof window > "u" || t.value)
        return !1;
      const o = c(e.scrollPosition), n = {
        bottom: e.scrollPosition.y + window.innerHeight,
        left: e.scrollPosition.x,
        right: e.scrollPosition.x + window.innerWidth,
        top: e.scrollPosition.y
      };
      return n.top - e.threshold <= o.bottom && n.bottom + e.threshold >= o.top && n.left - e.threshold <= o.right && n.right + e.threshold >= o.left;
    }
    function a() {
      var o;
      d() && ((o = e.onVisible) == null || o.call(e));
    }
    X(() => {
      l.value && t.value && (t.value.onVisible = e.onVisible, l.value.observe(t.value)), r.value || a == null || a();
    });
    const i = h(() => ({
      display: "inline-block",
      height: `${e.height}px`,
      width: `${e.width}px`
    }));
    return console.log("props", e), () => y("span", {
      ref: t,
      style: i.value
    }, [e.placeholder]);
  }
});
var oe = typeof global == "object" && global && global.Object === Object && global;
const le = oe;
var ae = typeof self == "object" && self && self.Object === Object && self, ce = le || ae || Function("return this")();
const G = ce;
var ue = G.Symbol;
const L = ue;
var Z = Object.prototype, de = Z.hasOwnProperty, se = Z.toString, w = L ? L.toStringTag : void 0;
function fe(e) {
  var t = de.call(e, w), r = e[w];
  try {
    e[w] = void 0;
    var l = !0;
  } catch {
  }
  var c = se.call(e);
  return l && (t ? e[w] = r : delete e[w]), c;
}
var ge = Object.prototype, he = ge.toString;
function ye(e) {
  return he.call(e);
}
var be = "[object Null]", me = "[object Undefined]", R = L ? L.toStringTag : void 0;
function ve(e) {
  return e == null ? e === void 0 ? me : be : R && R in Object(e) ? fe(e) : ye(e);
}
function we(e) {
  return e != null && typeof e == "object";
}
var Oe = "[object Symbol]";
function Pe(e) {
  return typeof e == "symbol" || we(e) && ve(e) == Oe;
}
var Ie = /\s/;
function Le(e) {
  for (var t = e.length; t-- && Ie.test(e.charAt(t)); )
    ;
  return t;
}
var Se = /^\s+/;
function Te(e) {
  return e && e.slice(0, Le(e) + 1).replace(Se, "");
}
function S(e) {
  var t = typeof e;
  return e != null && (t == "object" || t == "function");
}
var A = 0 / 0, je = /^[-+]0x[0-9a-f]+$/i, xe = /^0b[01]+$/i, Ee = /^0o[0-7]+$/i, Ne = parseInt;
function D(e) {
  if (typeof e == "number")
    return e;
  if (Pe(e))
    return A;
  if (S(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = S(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = Te(e);
  var r = xe.test(e);
  return r || Ee.test(e) ? Ne(e.slice(2), r ? 2 : 8) : je.test(e) ? A : +e;
}
var Ce = function() {
  return G.Date.now();
};
const N = Ce;
var ke = "Expected a function", Be = Math.max, We = Math.min;
function q(e, t, r) {
  var l, c, d, a, i, o, n = 0, s = !1, f = !1, b = !0;
  if (typeof e != "function")
    throw new TypeError(ke);
  t = D(t) || 0, S(r) && (s = !!r.leading, f = "maxWait" in r, d = f ? Be(D(r.maxWait) || 0, t) : d, b = "trailing" in r ? !!r.trailing : b);
  function P(u) {
    var g = l, m = c;
    return l = c = void 0, n = u, a = e.apply(m, g), a;
  }
  function W(u) {
    return n = u, i = setTimeout(v, t), s ? P(u) : a;
  }
  function V(u) {
    var g = u - o, m = u - n, x = t - g;
    return f ? We(x, d - m) : x;
  }
  function T(u) {
    var g = u - o, m = u - n;
    return o === void 0 || g >= t || g < 0 || f && m >= d;
  }
  function v() {
    var u = N();
    if (T(u))
      return j(u);
    i = setTimeout(v, V(u));
  }
  function j(u) {
    return i = void 0, b && l ? P(u) : (l = c = void 0, a);
  }
  function M() {
    i !== void 0 && clearTimeout(i), n = 0, l = o = c = i = void 0;
  }
  function $() {
    return i === void 0 ? a : j(N());
  }
  function I() {
    var u = N(), g = T(u);
    if (l = arguments, c = this, o = u, g) {
      if (i === void 0)
        return W(o);
      if (f)
        return clearTimeout(i), i = setTimeout(v, t), P(o);
    }
    return i === void 0 && (i = setTimeout(v, t)), a;
  }
  return I.cancel = M, I.flush = $, I;
}
var Ve = "Expected a function";
function Me(e, t, r) {
  var l = !0, c = !0;
  if (typeof e != "function")
    throw new TypeError(Ve);
  return S(r) && (l = "leading" in r ? !!r.leading : l, c = "trailing" in r ? !!r.trailing : c), q(e, t, {
    leading: l,
    maxWait: t,
    trailing: c
  });
}
const $e = (e) => {
  const t = getComputedStyle(e, null);
  return t.getPropertyValue("overflow") + t.getPropertyValue("overflow-y") + t.getPropertyValue("overflow-x");
}, Fe = (e) => {
  if (!(e instanceof HTMLElement))
    return window;
  let t = e;
  for (; t && t instanceof HTMLElement; ) {
    if (/(scroll|auto)/.test($e(t)))
      return t;
    t = t.parentNode;
  }
  return window;
}, ze = (e) => /* @__PURE__ */ O({
  name: "ScrollAwareComponent",
  props: B(),
  setup(t, {
    attrs: r
  }) {
    const l = h(() => t.useIntersectionObserver && k()), c = _(null), d = H({
      x: F(),
      y: z()
    });
    if (!l.value)
      return null;
    function a() {
      l.value || (d.x = F(), d.y = z());
    }
    const i = h(() => Fe(c.value));
    function o() {
      typeof window > "u" || l || (i.value.addEventListener("scroll", a), window.addEventListener("resize", a), i.value !== document.body && window.addEventListener("scroll", a));
    }
    function n() {
      typeof window > "u" || l || (i.value.removeEventListener("scroll", a), window.removeEventListener("resize", a), i.value !== document.body && window.removeEventListener("scroll", a));
    }
    X(() => {
      o();
    }), K(() => {
      n();
    }), U(i, (f, b) => {
      b && n(), o();
    });
    const s = t.delayMethod === "debounce" ? q(a, t.delayTime) : Me(a, t.delayTime);
    return () => y(e, C(t, r, {
      scrollPosition: d,
      ref: c,
      onChangeScroll: s
    }), null);
  }
}), Re = /* @__PURE__ */ O({
  compatConfig: {
    MODE: 3
  },
  name: "PlaceholderWithTracking",
  inheritAttrs: !1,
  props: ie(),
  setup(e) {
    return () => y(Y, e, null);
  }
}), Ae = ze(Re), De = /* @__PURE__ */ O({
  compatConfig: {
    MODE: 3
  },
  name: "LazyLoadComponent",
  inheritAttrs: !1,
  props: B(),
  setup(e, {
    slots: t
  }) {
    var d, a;
    const r = H({
      visible: e.visibleByDefault ?? !1,
      loaded: !1,
      error: !1
    }), l = h(() => !!(e.scrollPosition && Number.isFinite(e.scrollPosition.x) && e.scrollPosition.x >= 0 && Number.isFinite(e.scrollPosition.y) && e.scrollPosition.y >= 0));
    U(r, (i, o) => {
      var n;
      i.visible !== (o == null ? void 0 : o.visible) && ((n = e.afterLoad) == null || n.call(e));
    }, {
      immediate: !0
    });
    const c = () => {
      var i;
      r.visible = !0, (i = e.afterLoad) == null || i.call(e);
    };
    return e.visibleByDefault && ((d = e.beforeLoad) == null || d.call(e), (a = e.afterLoad) == null || a.call(e)), () => {
      var i;
      return r.visible ? (i = t.default) == null ? void 0 : i.call(t) : l.value || e.useIntersectionObserver && k() ? y(Y, {
        height: e.height,
        onVisible: c,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null) : y(Ae, {
        height: e.height,
        onVisible: c,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width
      }, null);
    };
  }
});
function _e(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !p(e);
}
const He = /* @__PURE__ */ O({
  name: "LazyLoadImage",
  compatConfig: {
    MODE: 3
  },
  inheritAttrs: !1,
  props: ne(),
  setup(e, {
    attrs: t
  }) {
    const r = Q(!1);
    function l() {
      if (!r.value)
        return (n) => {
          var s;
          (s = e.afterLoad) == null || s.call(e, n), r.value = !0;
        };
    }
    function c() {
      const n = h(() => {
        const {
          class: s,
          afterLoad: f,
          beforeLoad: b,
          delayMethod: P,
          delayTime: W,
          effect: V,
          placeholder: T,
          placeholderSrc: v,
          scrollPosition: j,
          threshold: M,
          useIntersectionObserver: $,
          visibleByDefault: I,
          wrapperClassName: u,
          wrapperProps: g,
          style: m,
          loadedClassName: x,
          ...J
        } = e;
        return J;
      });
      return y("img", C({
        onLoad: l(),
        onError: e.onImageError
      }, n.value, t), null);
    }
    function d() {
      let n;
      return y(De, {
        beforeLoad: e.beforeLoad,
        class: e.class,
        delayMethod: e.delayMethod,
        delayTime: e.delayTime,
        height: e.height,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        style: e.style,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        visibleByDefault: e.visibleByDefault,
        width: e.width
      }, _e(n = c()) ? n : {
        default: () => [n]
      });
    }
    const a = h(() => r.value ? " lazy-load-image-loaded" : ""), i = h(() => r.value || !e.placeholderSrc ? {} : {
      backgroundImage: `url(${e.placeholderSrc})`,
      backgroundSize: "100% 100%"
    });
    function o(n) {
      return y("span", C({
        class: e.wrapperClassName + " lazy-load-image-background " + e.effect + a.value,
        style: {
          ...i.value,
          color: "transparent",
          display: "inline-block",
          height: e.height + "px",
          width: e.width + "px"
        }
      }, e.wrapperProps), [n]);
    }
    return () => {
      const n = d();
      return !((e.effect || e.placeholderSrc) && !e.visibleByDefault) && !e.wrapperClassName && !e.wrapperProps ? n : o(n);
    };
  }
});
export {
  De as LazyLoadComponent,
  He as LazyLoadImage,
  ze as trackWindowScroll
};
